// 2006 U
// eNX`̂߂̃NX

using System;
using System.Drawing;
using OpenGL;


#region public static class BmpConverter

/// <summary>
/// rbg}bvzɕϊ
/// </summary>
public static class BmpConverter
{

    /// <summary>
    /// BitmapNX̃CX^Xbyte[]^RGBAz쐬
    /// </summary>
    /// <param name="bmp">rbg}bv</param>
    /// <returns>RGBAz</returns>
    public static void ConvertBitmapToByteArrayRGBA( out byte[] pixels, Bitmap bmp )
    {
        int width = bmp.Width, height = bmp.Height;
        pixels = new byte[width * height * 4];	//[height][4];


        bmp.RotateFlip( RotateFlipType.RotateNoneFlipY );

        System.Drawing.Imaging.BitmapData bmpData = bmp.LockBits(
                                                                    new Rectangle( 0, 0, bmp.Width, bmp.Height ),
                                                                    System.Drawing.Imaging.ImageLockMode.ReadOnly,
                                                                    System.Drawing.Imaging.PixelFormat.Format32bppArgb );

        System.Runtime.InteropServices.Marshal.Copy( bmpData.Scan0, pixels, 0, pixels.Length );

        bmp.UnlockBits( bmpData );


        byte r, b;
        int n;
        for( int i = 0; i < width * height; ++i )
        {
            n = i * 4;

            b = pixels[n];
            r = pixels[n + 2];

            pixels[n] = r;
            pixels[n + 2] = b;
        }

        /* łoȂƂ͂ȂAɏxx̂ŁA
         * ܂pIł͂ȂB
        int i, j, index=0;
        Color col;
			
        for(i=0; i<height; i++)
        {
            for(j=0; j<width; ++j)
            {
                col = bmp.GetPixel(j,i);
                pixels[index++] = col.R;
                pixels[index++] = col.G;
                pixels[index++] = col.B;
                pixels[index++] = col.A;
            }
        }
        */
    }
}
#endregion public static class BmpConverter

//#######################################################################
//#######################################################################

#region public class Texture2D

/// <summary>
/// 2̃eNX`\NX
/// </summary>
public class Texture2D : IDisposable
{

    #region oϐEvpeB

    /// <summary>
    /// eNX`̐ƂȂt@C̃pX
    /// </summary>
    private string filePath = "";
    /// <summary>
    /// eNX`̐ƂȂt@C̃pX
    /// </summary>
    public string FilePath
    {
        get { return this.filePath; }
    }

    /// <summary>
    /// OpenGLɂė^ÃeNX`̎ʔԍ
    /// </summary>
    private uint[] name = new uint[1];

    /// <summary>
    /// OpenGLɂė^ÃeNX`̎ʔԍ擾B
    /// </summary>
    public uint Name
    {
        get { return this.name[0]; }
    }

    /// <summary>
    /// GL_TEXTURE_2DɓB
    /// </summary>
    private readonly int target = gl.TEXTURE_2D;

    /// <summary>
    /// ^[QbgBGL_TEXTURE_2DɓB
    /// </summary>
    public int Target
    {
        get { return this.target; }
    }

    /// <summary>
    /// ̃eNX`̃xB
    /// </summary>
    private int level = 0;

    /// <summary>
    /// ̃eNX`̃x擾B
    /// </summary>
    public int Level
    {
        get { return this.level; }
    }

    /// <summary>
    /// 1sNZ̐Fvf̐
    /// </summary>
    private int compornents = 4;
    /// <summary>
    /// 1sNZ̐Fvf̐
    /// </summary>
    public int Components
    {
        get { return this.compornents; }
    }

    /// <summary>
    /// ̃eNX`̕
    /// </summary>
    private int width = 0;
    /// <summary>
    /// ̃eNX`̍
    /// </summary>
    private int height = 0;

    /// <summary>
    /// ̃eNX`̕擾B
    /// </summary>
    public int Width
    {
        get { return this.width; }
    }
    /// <summary>
    /// ̃eNX`̍擾B
    /// </summary>
    public int Height
    {
        get { return this.height; }
    }

    /// <summary>
    /// eNX`̋Eꍇ1Aꍇ0B
    /// </summary>
    private int border = 0;
    /// <summary>
    /// eNX`̋Eꍇ1Aꍇ0B
    /// </summary>
    public int Border
    {
        get { return this.border; }
    }

    /// <summary>
    /// 1sNZ̐Fvf̌`\tO
    /// </summary>
    private int format = gl.RGBA;
    /// <summary>
    /// 1sNZ̐Fvf̌`\tO擾B
    /// </summary>
    public int Format
    {
        get { return this.format; }
    }

    /// <summary>
    /// sNZf[^ێž^\tO
    /// </summary>
    private int type = gl.UNSIGNED_BYTE;
    /// <summary>
    /// sNZf[^ێž^\tO擾B
    /// </summary>
    public int Type
    {
        get { return this.type; }
    }

    /// <summary>
    /// OpenGLŃeNX`쐬ς݂ǂtO
    /// </summary>
    private bool genTexure = false;
    /// <summary>
    /// OpenGLŃeNX`쐬ς݂ǂtO
    /// </summary>
    public bool TextureGened
    {
        get { return this.genTexure; }
    }

    #endregion oEvpeB

    #region RXgN^

    /// <summary>
    /// w肵摜t@CeNX`쐬B
    /// </summary>
    /// <param name="textureFilePath">eNX`̌ƂȂ摜t@C̃pX</param>
    public Texture2D( string textureFilePath )
    {
        this.filePath = textureFilePath;
        this.GenTexture( textureFilePath );
    }


    #endregion RXgN^

    #region private void GenTexture( string filePath )

    /// <summary>
    /// OpenGLŃeNX`IuWFNg̐sB
    /// </summary>
    private void GenTexture( string filePath )
    {
        //摜t@CǂݍށB

        if( !System.IO.File.Exists( filePath ) )
        {
            throw new System.IO.FileNotFoundException( "t@C܂B : " + filePath, filePath );
        }
        Bitmap bmp = new Bitmap( filePath );

        this.width = bmp.Width;
        this.height = bmp.Height;

        //摜f[^i[Ăz
        byte[] imageByteArray;

        //bmpĂ邩摜f[^imageByteArrayփRs[B
        BmpConverter.ConvertBitmapToByteArrayRGBA( out imageByteArray, bmp );

        //bmp͌ƁB
        bmp.Dispose();

        //eNX`̃TCY`FbNA2nŖꍇ͎IɃXP[OsB
        this.CheckSizeAndScale( ref imageByteArray );

        //́AeNX`̂܂̎菇B
        gl.GenTextures( 1, this.name );

        this.Bind();

        gl.PixelStorei( gl.UNPACK_ALIGNMENT, 1 );

        gl.TexImage2D( this.target, this.level, this.compornents, this.width, this.height,
                                this.border, this.format, this.type, imageByteArray );

        //eNX`p[^̐ݒ
        gl.TexParameteri( gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR );

        gl.TexParameteri( gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR );

        this.genTexure = true;
    }

    #endregion private void GenTexture( string filePath )

    #region public void Bind()

    /// <summary>
    /// ̃eNX`oChB
    /// ܂Ã݂eNX`ɐݒ肷B
    /// </summary>
    public void Bind()
    {
        gl.BindTexture( gl.TEXTURE_2D, this.name[0] );
    }

    #endregion public void Bind()

    #region private void CheckSizeAndScale( ref byte[] texture )

    /// <summary>
    /// eNX`̃TCY`FbNA2nŖꍇ͎IɃXP[OsB
    /// </summary>
    /// <param name="texture"></param>
    private void CheckSizeAndScale( ref byte[] texture )
    {
        float log_2_w, log_2_h;
        log_2_w = (float)Math.Log( this.width, 2 );
        log_2_h = (float)Math.Log( this.height, 2 );

        float dw = log_2_w - (int)log_2_w;
        float dh = log_2_h - (int)log_2_h;

        if( dw > 0 || dh > 0 )
        {

            int w_out = this.width;
            if( dw != 0 )
            {
                w_out = (int)Math.Pow( 2, (int)log_2_w + 1 );
            }

            int h_out = this.height;
            if( dh != 0 )
            {
                h_out = (int)Math.Pow( 2, (int)log_2_h + 1 );
            }
            byte[] tex_out = new byte[w_out * h_out * compornents];

            //OpenGL.csglu.ScaleImage\bh̃I[o[[hǉĂB
            //IntPtrł͎gɂ̂ŁB
            glu.ScaleImage( this.format, this.width, this.height, this.type, texture,
                        w_out, h_out, this.type, tex_out );

            this.width = w_out;
            this.height = h_out;
            texture = tex_out;
        }
    }

    #endregion private void CheckSizeAndScale( ref byte[] texture )

    #region IDisposable o
    /// <summary>
    /// ̃IuWFNgj鎞ɁA
    /// glDeleteTextures OpenGLɓo^ĂeNX`jB
    /// </summary>
    public virtual void Dispose()
    {
        if( this.name != null )
        {
            try
            {
                //OpenGL.csɂāAgl.DeleteTextures̈Ȃ
                //gl.DeleteTextures( int n, int[] texturs )@i2int[]^ł͂Ȃuint[]ł́Hj
                //ƂȂĂ̂ŁA2̌^Aint[]  uint[] ɏĂB
                gl.DeleteTextures( 1, this.name );
            }
            catch { }
            finally { }
        }
    }

    #endregion
}

#endregion public class Texture
